

Imports System.Runtime.InteropServices
Imports System.Text
Imports LC.Multimedia

Public Partial Class InputDevice
    Inherits MidiDevice

	Protected Overloads Overrides Sub Dispose(disposing As Boolean)
		If disposing Then
			SyncLock lockObject
				Reset()
                Dim result As Integer = midiInClose(m_handle)

				If result = MidiDeviceException.MMSYSERR_NOERROR Then
					delegateQueue.Dispose()
				Else
					Throw New InputDeviceException(result)
				End If
			End SyncLock
		Else
            midiInReset(m_handle)
            midiInClose(m_handle)
		End If
		MyBase.Dispose(disposing)
	End Sub
End Class


Public Class InputDeviceException
    Inherits MidiDeviceException

    <DllImport("winmm.dll")> _
    Private Shared Function midiInGetErrorText(ByVal errCode As Integer, ByVal errMsg As StringBuilder, ByVal sizeOfErrMsg As Integer) As Integer
    End Function

    Private errMsg As New StringBuilder(128)

    Public Sub New(ByVal errCode As Integer)
        MyBase.New(errCode)
        midiInGetErrorText(errCode, errMsg, errMsg.Capacity)
    End Sub

    Public Overloads Overrides ReadOnly Property Message() As String
        Get
            Return errMsg.ToString()
        End Get
    End Property

End Class
