
Imports System.Collections.Generic
Imports System.Threading

Public MustInherit Class Device
    Implements IDisposable

    Protected Const CALLBACK_FUNCTION As Integer = &H30000
    Protected Const CALLBACK_EVENT As Integer = &H50000
    Private m_deviceID As Integer
    Protected context As SynchronizationContext
    Private disposed As Boolean = False

    Public Event Error_ As EventHandler(Of ErrorEventArgs)


    Public Sub New(ByVal deviceID As Integer)
        Me.m_deviceID = deviceID

        If SynchronizationContext.Current Is Nothing Then
            context = New SynchronizationContext()
        Else
            context = SynchronizationContext.Current
        End If
    End Sub

    Protected Overridable Overloads Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            disposed = True
            GC.SuppressFinalize(Me)
        End If
    End Sub

    Protected Overridable Sub OnError(ByVal e As ErrorEventArgs)
        'Dim handler As EventHandler(Of ErrorEventArgs) = [Error]
        'If handler IsNot Nothing Then
        '	context.Post(Function(dummy As Object) Do
        '          handler(Me, e)
        '	End Function, Nothing)
        'End If
        context.Post(Function(dummy As Object) Error_Function(e), Nothing)
    End Sub
    Private Function Error_Function(ByVal e As ErrorEventArgs) As Boolean
        RaiseEvent Error_(Me, e)
    End Function


    Public MustOverride Sub Close()

    Public MustOverride Sub Reset()

    Public MustOverride ReadOnly Property Handle() As Integer


    Public ReadOnly Property DeviceID() As Integer
        Get
            Return m_deviceID
        End Get
    End Property

    Public ReadOnly Property IsDisposed() As Boolean
        Get
            Return disposed
        End Get
    End Property

#Region "IDisposable"

    Public MustOverride Overloads Sub Dispose() Implements System.IDisposable.Dispose

#End Region


End Class
